#include "ADO.au3"
#Tidy_Parameters=/sort_funcs /reel
#AutoIt3Wrapper_Au3Check_Parameters=-d -w 1 -w 2 -w 3 -w- 4 -w 5 -w 6 -w 7

#include <Array.au3>
#include <MsgBoxConstants.au3>
#include <AutoItConstants.au3>

Global $sDSN = 'PostgreSQL35W'
Global $sDatabase = ''
Global $sServer = ''
Global $sPort = ''
Global $sUser = ''
Global $sPassword = ''
Global $sConnectionString = 'DSN=' & $sDSN & ';DATABASE=' & $sDatabase & ';SERVER=' & $sServer & ';PORT=' & $sPort & ';UID=' & $sUser & ';PWD=' & $sPassword & ';'

; Internal ADO.au3 UDF COMError Handler
_ADO_ComErrorHandler_UserFunction(_ADO_COMErrorHandler)

_Example_PostgreSQL_1()
_Example_PostgreSQL_2()
_Example_PostgreSQL_3()

Func _Example_PostgreSQL_1()

	_ADO_Connection_OpenConString($oConnection, $sConnectionString)
	If @error Then Return SetError(@error, @extended, $ADO_RET_FAILURE)

	Local $sTableName = 'SOME_TABLE_NAME'
	Local $sQUERY = 'Select * from ' & $sTableName
	Local $oRecordset = _ADO_Execute($oConnection, $sQUERY)

	Local $aRecordsetArray = _ADO_Recordset_ToArray($oRecordset, False)

	Local $aRecordset_inner = _ADO_RecordsetArray_GetContent($aRecordsetArray)

	Local $iColumn_count = UBound($aRecordset_inner, $UBOUND_COLUMNS)
	For $iRecord_idx = 0 To UBound($aRecordset_inner) - 1
		ConsoleWrite('==================================================================' & @CRLF)
		For $iColumn_idx = 0 To $iColumn_count - 1
			ConsoleWrite($aRecordset_inner[$iRecord_idx][$iColumn_idx] & @CRLF)
		Next
	Next

	; CleanUp
	$oRecordset = Null
	_ADO_Connection_Close($oConnection)
	$oConnection = Null

EndFunc    ;==>_Example_PostgreSQL_1

Func _Example_PostgreSQL_2()

	Local $oConnection = _ADO_Connection_Create()
	_ADO_Connection_OpenConString($oConnection, $sConnectionString)
	If @error Then Return SetError(@error, @extended, $ADO_RET_FAILURE)

	Local $sTableName = 'SOME_TABLE_NAME'
	Local $sQUERY = 'Select * from ' & $sTableName
	Local $aRecordset = _ADO_Execute($oConnection, $sQUERY, True)

	; CleanUp
	_ADO_Connection_Close($oConnection)
	$oConnection = Null

	_ADO_REcordset_Display($aRecordset, $sTableName & '  - Recordset content')

EndFunc    ;==>_Example_PostgreSQL_2

Func _Example_PostgreSQL_3()
	Local $oConnection = _ADO_Connection_Create()
	_ADO_Connection_OpenConString($oConnection, $sConnectionString)
	If @error Then Return SetError(@error, @extended, $ADO_RET_FAILURE)

	Local $aProperties = _ADO_Connection_PropertiesToArray($oADOConnection)

	; CleanUp
	_ADO_Connection_Close($oConnection)
	$oConnection = Null

	_ArrayDisplay($aProperties, "ADO connection - List of properties", "", 0, Default, "Name|Type|Value|Attributes")

EndFunc    ;==>_Example_PostgreSQL_3
